//#define EBATWO
#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
#endregion

//namespace MVR.FileManagementSecure{
namespace Cotyounoyume{
	public class CustomUI
	{
		public EBATCore core;
		public Atom atom;
		
		public Expression2 expression2;
		public Blushing blushing;
		public Tears tears;
		public EyesControl eyesControl;
		public Belly belly;
		public Etc etc;
		public BodyMorph bodyMorph;
		public UnityAssets unityAssets;
		public WorldUI worldUi;
		public Sound sound;
		public HeadController headController;
		
#if	(EBATWO)
		public Orgasm orgasm;
#endif		

		public SimpleJSON.JSONClass settingsRoot;
		public SimpleJSON.JSONClass settings;
		public int[] stageThreshold;
		
		public Dictionary<string, UIDynamic>                 dUISpacer = new Dictionary<string, UIDynamic>();
		public Dictionary<string, UIDynamicButton>           dUIButton = new Dictionary<string, UIDynamicButton>();		
		public Dictionary<string, UIDynamicToggle>           dUIToggle = new Dictionary<string, UIDynamicToggle>();
		public Dictionary<string, JSONStorableBool>          dJSToggle = new Dictionary<string, JSONStorableBool>();
		public Dictionary<string, UIDynamicSlider>           dUISlider = new Dictionary<string, UIDynamicSlider>();
		public Dictionary<string, JSONStorableFloat>         dJSSlider = new Dictionary<string, JSONStorableFloat>();
		public Dictionary<string, UIDynamicTextField>        dUIString = new Dictionary<string, UIDynamicTextField>();
		public Dictionary<string, JSONStorableString>        dJSString = new Dictionary<string, JSONStorableString>();
		public Dictionary<string, UIDynamicPopup>            dUIPopup  = new Dictionary<string, UIDynamicPopup>();
		public Dictionary<string, JSONStorableStringChooser> dJSPopup  = new Dictionary<string, JSONStorableStringChooser>();

		public Dictionary<string, bool>                      dOpenState = new Dictionary<string, bool>();
		
		#region ui var
		protected Color colorDefault = new Color(0.8f, 0.8f, 0.8f);
		
		public JSONStorableString  jsSoundTypePersonal;

		public JSONStorableFloat jsCanvasPositionX;
		public JSONStorableFloat jsCanvasPositionY;
		public JSONStorableFloat jsCanvasPositionZ;
		public JSONStorableFloat jsCanvasRotationX;
		public JSONStorableFloat jsCanvasRotationY;
		public JSONStorableFloat jsCanvasRotationZ;
		public JSONStorableFloat jsCanvasRotationW;		
		#endregion
		
		public string[] expandsNames = {
				"Toggles for Main Features",
//				"MorphForOrgasm Menu", "MorphForEmotions Menu",
				"Sliders for Main Features", "Sliders for Stage Thresholds", "Sliders for Orgasm Features",
				"Sound Menu",
		};
		
		public CustomUI(EBATCore core){
			this.core = core;
			this.atom = core.atom;
		}
		
		#region settings
		public void loadSettings(){
			this.expression2 = core.expression2;
			this.blushing = core.blushing;
			this.tears = core.tears;
			this.eyesControl = core.eyesControl;
			this.belly = core.belly;
			this.etc = core.etc;
			this.bodyMorph = core.bodyMorph;
			this.unityAssets = core.unityAssets;
			this.worldUi = core.worldUi;
			this.sound = core.sound;			
			this.settingsRoot = core.settingsRoot;
			this.settings = core.settings;
			this.stageThreshold = core.stageThreshold;
			this.headController = core.headController;
#if	(EBATWO)
			this.orgasm = core.orgasm;
#endif
			SetJSONStorage();
		}
		
		public void SetJSONStorage(){
			jsSoundTypePersonal = new JSONStorableString("Sound Type(Personal)", "default");
			core.RegisterString(jsSoundTypePersonal);
			jsCanvasPositionX   = new JSONStorableFloat("Canvas Position X", 0f, -10f, 10f);
			jsCanvasPositionY   = new JSONStorableFloat("Canvas Position Y", 0f, -10f, 10f);
			jsCanvasPositionZ   = new JSONStorableFloat("Canvas Position Z", 0f, -10f, 10f);
			jsCanvasRotationX   = new JSONStorableFloat("Canvas Rotation X", 0f, -10f, 10f);
			jsCanvasRotationY   = new JSONStorableFloat("Canvas Rotation Y", 0f, -10f, 10f);
			jsCanvasRotationZ   = new JSONStorableFloat("Canvas Rotation Z", 0f, -10f, 10f);
			jsCanvasRotationW   = new JSONStorableFloat("Canvas Rotation W", 0f, -10f, 10f);
			core.RegisterFloat(jsCanvasPositionX);
			core.RegisterFloat(jsCanvasPositionY);
			core.RegisterFloat(jsCanvasPositionZ);
			core.RegisterFloat(jsCanvasRotationX);
			core.RegisterFloat(jsCanvasRotationY);
			core.RegisterFloat(jsCanvasRotationZ);
			core.RegisterFloat(jsCanvasRotationW);
		}
		
		public void MemorizeUIPosition(){
			jsCanvasPositionX.val = worldUi.UIAtom.mainController.transform.position.x;
			jsCanvasPositionY.val = worldUi.UIAtom.mainController.transform.position.y;
			jsCanvasPositionZ.val = worldUi.UIAtom.mainController.transform.position.z;
			
			jsCanvasRotationX.val = worldUi.UIAtom.mainController.transform.rotation.x;
			jsCanvasRotationY.val = worldUi.UIAtom.mainController.transform.rotation.y;
			jsCanvasRotationZ.val = worldUi.UIAtom.mainController.transform.rotation.z;
			jsCanvasRotationW.val = worldUi.UIAtom.mainController.transform.rotation.w;
		}
		#endregion
		
		#region MakeVariables
		public void MakeVariableToggle(string name, bool initial){
			JSONStorableBool jsb = new JSONStorableBool(name, initial, (bool toggle) => {ToggleAny(name);});
			core.RegisterBool(jsb);
			if(dJSToggle.ContainsKey(name)) dJSToggle[name] = jsb;
			else dJSToggle.Add(name, jsb);
		}
		
		public void MakeVariablePopup(string name, List<string> options, string initial){
			JSONStorableStringChooser jssc = new JSONStorableStringChooser(name, options, initial, name, (string choice) => {SelectAny(name, choice);});
			core.RegisterStringChooser(jssc);
			if(dJSPopup.ContainsKey(name)) dJSPopup[name] = jssc;
			else dJSPopup.Add(name, jssc);
		}

		public void MakeVariableString(string name, string text){
			JSONStorableString jss = new JSONStorableString(name, text);
			core.RegisterString(jss);
			if(dJSString.ContainsKey(name)) dJSString[name] = jss;
			else dJSString.Add(name, jss);			
		}
		
		public void MakeVariableSliderNoFunc(string displayName, float initial, float min, float max){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, min, max);
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);			
		}		
		
		public void MakeVariableSlider(string displayName, float initial, float min, float max, string category, string name){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, (float value) => {
				SetSliderValue(displayName, value);
				settings[category][displayName] = value.ToString();
//				saveConfig();
			}, min, max);
			
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);			
		}
		#endregion
		
		#region Callback Functions		
		public void SelectAny(string name, string choice){
			string normalizedChoice = "";
			if(name == "DefaultBlushType" || name == "Blush Type"){
				normalizedChoice = choice;
				blushing.blushTypeDefault = normalizedChoice;				
				if(blushing.blushOnGlobal) blushing.RemoveBlushing();
			}else if(name == "DefaultTearsType" || name == "Tears Type"){
				normalizedChoice = choice;
				tears.tearsTypeDefault = normalizedChoice;
				tears.setTearsType(choice);
			}else if(name == "DefaultSoundType" || name == "Sound Type(Default)"){
				normalizedChoice = choice;
				sound.soundTypeDefault = normalizedChoice;
			}else if(name == "PersonalSoundType" || name == "Sound Type(Personal)"){
				normalizedChoice = choice;
				jsSoundTypePersonal.val = choice;
				sound.UpdateSound();
			}
			
			if(name == "PersonalSoundType" || name == "Sound Type(Personal)"){ // for no settings types
			}else{ // for settings types
				settings["General"][name] = normalizedChoice;
//				saveConfig();
			}
		}
		
		public void ToggleAny(string name){
			if(name == "TearsOn" || name == "Tears On") 					
				ToggleAnyAlias(ref tears.tearsOnGlobal, name);
			else if(name == "DroolOn" || name == "Drool On")				
				ToggleAnyAlias(ref tears.droolOnGlobal, name);
			else if(name == "ExpressionOn" || name == "Expression On")
				ToggleAnyAlias(ref expression2.expressionOnGlobal, name);
			else if(name == "BlushOn" || name == "Blush On")				
				ToggleAnyAlias(ref blushing.blushOnGlobal, name);
			else if(name == "EyesControlOn" || name == "Eyes Control On") 		
				ToggleAnyAlias(ref eyesControl.eyecontrolOnGlobal, name);
			else if(name == "EyesRollupOn" || name == "Eyes Rollup On")			
				ToggleAnyAlias(ref eyesControl.eyecontrolRollupOnGlobal, name);
			else if(name == "SoundOn" || name == "Sound On") 				
				ToggleAnyAlias(ref sound.soundOnGlobal, name);
			else if(name == "NippleErectionOn" || name == "Nipple Erection On") 	
				ToggleAnyAlias(ref bodyMorph.nippleErectionOnGlobal, name);
			else if(name == "ClitorisErectionOn" || name == "Clitoris Erection On")	
				ToggleAnyAlias(ref bodyMorph.clitorisErectionOnGlobal, name);
			else if(name == "Head Motion On")	
				ToggleAnyAlias(ref headController.headMotionOnGlobal, name);
			else if(name == "PeeingOn" || name == "Peeing On")				
				ToggleAnyAlias(ref unityAssets.peeingOnGlobal, name);
			else if(name == "AutoExpressionsOff" || name == "Auto Expression Off") 	
				ToggleAnyAlias(ref etc.autoExpressionOffGlobal, name);
			else if(name == "AutoBlinkOff" || name == "Auto Blink Off")			
				ToggleAnyAlias(ref etc.autoBlinkOffGlobal, name);
			else if(name == "UIMenuOn" || name == "Display UI Menu")				
				ToggleAnyAlias(ref core.menuOnGlobal, name);
			else if(name == "DebugMessageOff" || name == "Debug Message Off")
				ToggleAnyAlias(ref core.disableLog, name);
		}
		
		public void ToggleAnyAlias(ref bool x, string name){
			ToggleAnyBase(ref x, name);
			ToggleAnyAdditional(ref x, name);
		}
		
		public void ToggleAnyBase(ref bool x, string name){
			x = x ? false : true;
			if(name == "DebugMessageOff" || name == "Debug Message Off"){
				settingsRoot["Common"]["General"][name] = x ? "true" : "false";
			}else{
				settings["General"][name] = x ? "true" : "false";
			}
//			saveConfig();			
		}
		
		public void ToggleAnyAdditional(ref bool x, string name){
			if(name == "Tears On") 					tears.refreshTears();
			else if(name == "Drool On")				tears.refreshTears();
			else if(name == "Expression On")			if(x) expression2.update(); else expression2.stopExpression();
			else if(name == "Blush On")				if(x) blushing.update(Time.time); else blushing.RemoveBlushing();
			else if(name == "Eyes Control On") 		if(x) eyesControl.EyesControlOn(); else eyesControl.EyesControlOff();
//			else if(name == "Eyes Rollup On")			//nop
//			else if(name == "Sound On") 				//nop
			else if(name == "Nipple Erection On") 	if(x) bodyMorph.update(Time.time); else bodyMorph.stopBodyMorph();
			else if(name == "Clitoris Erection On")	if(x) bodyMorph.update(Time.time); else bodyMorph.stopBodyMorph();
//			else if(name == "Head Motion On")	//nop
			else if(name == "Peeing On")				if(x) unityAssets.resetUSPeeLong(Time.time); else ;
			else if(name == "Auto Expressions Off") 	atom.GetStorableByID("AutoExpressions").SetBoolParamValue("enabled", (!x));
			else if(name == "Auto Blink Off")			atom.GetStorableByID("EyelidControl").SetBoolParamValue("blinkEnabled", (!x));
			else if(name == "Display UI Menu")				if(x) worldUi.makeWorldUI(); else worldUi.RemoveMenuAll();	
			else if(name == "Debug Message Off"){
				x = x ? false : true;
				blushing.disableLog = x;
				core.logger("disableLog: " + core.disableLog);
			}
			core.worldUi.ReloadMenu();
		}

		public void SetSliderValue(string name, float value){
			if(name == "ExpressionStrengthBase" || name == "Expression Strength")
 				expression2.fmm.baseMultiplier = value;
			else if(name == "EyesControlDurationTime" || name == "Eyes Control interval Time")
				eyesControl.eyecontrolClosingTimeInterval = value;
			else if(name == "BodyMorphDurationTime" || name == "BodyMorph Duration Time")
				bodyMorph.bodyMorphClosingTimeOffset = value;
			else if(name == "BlushDurationTime" || name == "Blush Duration Time")
				blushing.blushClosingTimeOffset = value;
			else if(name == "TearsDurationTime" || name == "Tears Duration Time")
				tears.tearsClosingTimeOffset = value;
			else if(name == "BreathStrength" || name == "Breath Strength")
				belly.targetStrength["chestControl"] = value;
			else if(name == "PeeingRatio" || name == "Peeing Ratio")
				unityAssets.peeingRatio = value;
			else if(name == "Pitch" || name == "Sound Pitch")
				sound.headAudioSource.pitch = value;
#if	(EBATWO)			
			else if(name == "OrgasmStrength" || name == "Orgasm Strength Max")
				orgasm.orgasmStrengthMax = value;
			else if(name == "AfterglowStrength" || name == "Afterglow Strength Max")
				orgasm.afterglowStrengthMax = value;
			else if(name == "WaveBigCycleMax" || name == "Orgasm Wave Big Cycle Count Max")
				orgasm.orgasmWaveCycleBigMax = (int)value;
			else if(name == "WaveBigCycleMin" || name == "Orgasm Wave Big Cycle Count Min")
				orgasm.orgasmWaveCycleBigMin = (int)value;
			else if(name == "WaveSmallCycleMax" || name == "Orgasm Wave Small Cycle Count Max")
				orgasm.orgasmWaveCycleSmallMax = (int)value;
			else if(name == "WaveSmallCycleMin" || name == "Orgasm Wave Small Cycle Count Min")
				orgasm.orgasmWaveCycleSmallMin = (int)value;
			else if(name == "AfterglowBigCycleMax" || name == "Orgasm Afterglow Big Cycle Count Max")
				orgasm.orgasmAfterglowCycleBigMax = (int)value;
			else if(name == "AfterglowBigCycleMin" || name == "Orgasm Afterglow Big Cycle Count Min")
				orgasm.orgasmAfterglowCycleBigMin = (int)value;
			else if(name == "AfterglowSmallCycleMax" || name == "Orgasm Afterglow Small Cycle Count Max")
				orgasm.orgasmAfterglowCycleSmallMax = (int)value;
			else if(name == "AfterglowSmallCycleMin" || name == "Orgasm Afterglow Small Cycle Count Min")
				orgasm.orgasmAfterglowCycleSmallMin = (int)value;
			else if(name == "WaveBigCycleIntervalMax" || name == "Orgasm Wave Big Cycle Interval Max")
				orgasm.orgasmWaveCycleIntervalBigMax = value;
			else if(name == "WaveSmallCycleIntervalMax" || name == "Orgasm Wave Small Cycle Interval Max")
				orgasm.orgasmWaveCycleIntervalSmallMax = value;
			else if(name == "AfterglowBigCycleIntervalMax" || name == "Orgasm Afterglow Big Cycle Interval Max")
				orgasm.orgasmAfterglowCycleIntervalBigMax = value;
			else if(name == "AfterglowSmallCycleIntervalMax" || name == "Orgasm Afterglow Small Cycle Interval Max")
				orgasm.orgasmAfterglowCycleIntervalSmallMax = value;
#endif
			else core.debug("ERROR: unknown name: " + name);
		}		
		
		public void ClickAny(string name){
			if(name == "Load Default"){
				try{
					core.worldUi.OnCloseMenuClick();
					expression2.stopExpression();
					bodyMorph.stopBodyMorph();
					core.logger("load default settings.");
					core.loadSettings("default");
					RemoveConfigMenu();
					saveConfig();
					//core.InitCore();
					//core.Start();
					
					Utility.ReloadPlugins(atom);
				}catch(Exception e){
					core.loggerE(e);
				}
//				core.Start();				
			}else if(name == "Save Configuration"){
				saveConfig();
			}else if(name == "Copy Sound File"){
				sound.CopySound();
			}else if(name == "Make her Orgasm"){
				core.setGauge(stageThreshold[5]);
				core.OnErogenousZoneTouch("DeeperVagina");
				core.updateAll();
				core.orgasmFunctions("orgasmStart", 0f);
			}else if(name == "Stop her Orgasm"){
				core.setGauge(stageThreshold[0]);
				core.orgasmFunctions("orgasmFinish", 0f);
			}else if(name == "Undress All"){
				tears.cm.undressAll();
			}else if(name == "Sound Test: Breath"){
				sound.playSound("breath", Time.time);
			}else if(name == "Sound Test: Moan"){
				sound.playSound("moan", Time.time);
			}else if(name == "Sound Test: Climax"){
				sound.playSound("climax", Time.time);
			}
		}		
		#endregion		
		
		#region UI Parts Common
		public void MakeUIPartPopup(string name, bool isRight){
			if(dJSPopup.ContainsKey(name) == false){
				core.debug("MakeUIPartPopup: unknown name: " + name);
				return;
			}			
			UIDynamicPopup ui = core.CreateScrollablePopup(dJSPopup[name], isRight);			
			if(dUIPopup.ContainsKey(name)) dUIPopup[name] = ui;
			else dUIPopup.Add(name, ui);
		}
		
		public void MakeUIPartToggle(string name, bool isRight){
			if(dJSToggle.ContainsKey(name) == false){
				core.debug("MakeUIPartToggle: unknown name: " + name);
				return;
			}
			UIDynamicToggle ui = core.CreateToggle(dJSToggle[name], isRight);
			if(dUIToggle.ContainsKey(name)) dUIToggle[name] = ui;
			else dUIToggle.Add(name, ui);
		}
		
		public void MakeUIPartSpacer(string name, string type, bool isRight){
			float height = 0f;
			if(type == "SectionSeparator") height = 16f;
			else if(type == "ButtonAndSectionSeparator") height = 50f;
			else if(type == "ButtonSkip") height = 50f;
			else if(type == "SliderSkip") height = 120f;
			else core.debug("ERROR:");
			
			MakeUIPartSpacer(name, height, isRight);
		}
		
		public void MakeUIPartSpacer(string name, float height, bool isRight){
			UIDynamic ui = core.CreateSpacer(isRight);
			ui.height = height;			
			if(dUISpacer.ContainsKey(name)) dUISpacer[name] = ui;
			else dUISpacer.Add(name, ui);
		}                   
		
		public void MakeUIPartButtonNoFunc(string name, bool isRight){
			MakeUIPartButtonNoFunc(name, isRight, colorDefault);
		}
		
		public void MakeUIPartButtonNoFunc(string name, bool isRight, Color color){
			UIDynamicButton ui = core.CreateButton(name, isRight);
			ui.buttonColor = color;
			if(dUIButton.ContainsKey(name)) dUIButton[name] = ui;
			else dUIButton.Add(name, ui);
		}
		
		public void MakeUIPartButton(string name, bool isRight){
			MakeUIPartButton(name, isRight, colorDefault);
		}
		
		public void MakeUIPartButton(string name, bool isRight, Color color){
			MakeUIPartButtonNoFunc(name, isRight, color);
			dUIButton[name].button.onClick.AddListener(()=>{ClickAny(name);});
		}                   
		
		public void MakeUIPartSlider(string name, bool isRight){
			if(dJSSlider.ContainsKey(name) == false){
				core.debug("MakeUIPartSlider: unknown name: " + name);
				return;
			}
			
			UIDynamicSlider ui = core.CreateSlider(dJSSlider[name], isRight);
			if(dUISlider.ContainsKey(name)) dUISlider[name] = ui;
			else dUISlider.Add(name, ui);
			
			if(name == "ExpressionStrengthBase" || name == "Expression Strength"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					worldUi.uiStrengthSlider.slider.value = value;
				});				
			}else if(name == "WaveBigCycleMax" || name == "Orgasm Wave Big Cycle Count Max"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					worldUi.uiWaveSlider.slider.value = value;
				});			
			}else if(name == "Sound Pitch"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					worldUi.uiPitchSlider.slider.value = value;
				});			
			}
		}	

		public void MakeUIPartString(string name, bool isRight){
			if(dJSString.ContainsKey(name) == false){
				core.debug("MakeUIPartString: unknown name: " + name);
				return;
			}
			UIDynamicTextField ui = core.CreateTextField(dJSString[name], isRight);
			if(dUIString.ContainsKey(name)) dUIString[name] = ui;
			else dUIString.Add(name, ui);			
		}
		#endregion
		
		#region UI Parts Special
		public void MakeUIPartButtonToggleMenu(string name){
			string displayName = !(dOpenState[name]) ? "[+]Expand " + name : "[-]Collapse " + name;
			MakeUIPartButtonNoFunc(displayName, false, Color.white);
			dUIButton[displayName].button.onClick.AddListener(()=>{
				RemoveConfigMenu();
				dOpenState[name] = !(dOpenState[name]);
				setupUI();	
			});
		}
		#endregion
		
		#region etc.
		public void saveConfig(){
			core.saveConfig();
		}
		
		public void InitExpandState(bool flag){
			foreach(var name in expandsNames){
				if(!dOpenState.ContainsKey(name)){
					dOpenState.Add(name, flag);
				}
			}
		}
		
		public void ExpandAll(bool flag){
			foreach(var name in expandsNames){
				dOpenState[name] = flag;
			}
		}
		#endregion
		
		#region UI MainMenu
		public void setupUI(){
			SetupUIActionButtons();
			SetupUIExpandMenu("Toggles for Main Features");
			if(dOpenState["Toggles for Main Features"]) SetupUIToggleButtons();
			SetupUIExpandMenu("Sliders for Main Features");
			if(dOpenState["Sliders for Main Features"]) SetupUISliders1();
			SetupUIExpandMenu("Sound Menu");
			if(dOpenState["Sound Menu"]) SetupUISound();
			SetupUIExpandMenu("Sliders for Stage Thresholds");
			if(dOpenState["Sliders for Stage Thresholds"]) SetupUISliders2();
#if (EBATWO)
			SetupUIExpandMenu("Sliders for Orgasm Features");
			if(dOpenState["Sliders for Orgasm Features"]) SetupUISliders3();
#endif
		}
		
		public void SetupUIExpandMenu(string name){
			MakeUIPartButtonToggleMenu(name);
			MakeUIPartSpacer("spacer_" + name, "ButtonAndSectionSeparator", true);
		}
	
		public string MakeName(string type, string tag, string key){
			return type + "_" + tag + "_" + key;
		}
		
		public string MakeName(string type, string tag, int i){
			return type + "_" + tag + "_" + i;
		}
		
		public string MakeExplanation(string key){
			string expPrefix = "MorphName:\n";
			string expSuffix = "\nFor this morph, you can\n - toggle enable/disable\n - limit strength\n - test morph";
			return expPrefix + key + expSuffix;
		}
		#endregion
				
		#region UI Detail
		public void SetupUIVariables(){
			//setupUIActionButtons
			MakeVariableToggle("Debug Message Off", core.disableLog);
			MakeVariableToggle("Display UI Menu", core.menuOnGlobal);
			//setupUIToggleButtons
			MakeVariableToggle("Auto Expression Off", etc.autoExpressionOffGlobal);
			MakeVariableToggle("Auto Blink Off", etc.autoBlinkOffGlobal);
			MakeVariableToggle("Expression On", expression2.expressionOnGlobal);
			MakeVariableToggle("Eyes Control On", eyesControl.eyecontrolOnGlobal);
			MakeVariableToggle("Eyes Rollup On", eyesControl.eyecontrolRollupOnGlobal);
			MakeVariableToggle("Blush On", blushing.blushOnGlobal);
			MakeVariableToggle("Tears On", tears.tearsOnGlobal);
			MakeVariableToggle("Drool On", tears.droolOnGlobal);
			MakeVariableToggle("Sound On", sound.soundOnGlobal);
			MakeVariableToggle("Nipple Erection On", bodyMorph.nippleErectionOnGlobal);
			MakeVariableToggle("Clitoris Erection On", bodyMorph.clitorisErectionOnGlobal);
			MakeVariableToggle("Head Motion On", headController.headMotionOnGlobal);
			MakeVariableToggle("Peeing On", unityAssets.peeingOnGlobal);
			MakeVariablePopup("Blush Type", blushing.blushTypes, blushing.blushTypeDefault);
			MakeVariablePopup("Tears Type", tears.tearsTypes, tears.tearsTypeDefault);
			MakeVariablePopup("Sound Type(Default)", sound.soundTypes, sound.soundTypeDefault);
			MakeVariablePopup("Sound Type(Personal)", sound.soundTypes, jsSoundTypePersonal.val);
			//setupUISliders1
			MakeVariableSlider("Expression Strength", expression2.fmm.baseMultiplier, 0f, 1.2f, "General", "Expression Strength");
			MakeVariableSlider("Eyes Control interval Time", eyesControl.eyecontrolClosingTimeInterval, 0f, 60f, "General", "EyesControlDurationTime");
			MakeVariableSlider("BodyMorph Duration Time", bodyMorph.bodyMorphClosingTimeOffset, 0f, 60f, "General", "BodyMorphDurationTime");
			MakeVariableSlider("Blush Duration Time", blushing.blushClosingTimeOffset, 0f, 60f, "General", "BlushDurationTime");
			MakeVariableSlider("Tears Duration Time", tears.tearsClosingTimeOffset, 0f, 60f, "General", "TearsDurationTime");
			MakeVariableSlider("Breath Strength", belly.targetStrength["chestControl"], -60f, 60f, "General", "BreathStrength");
			MakeVariableSlider("Peeing Ratio", unityAssets.peeingRatio, 0f, 1f, "General", "PeeingRatio");
			//setupUISound
			string explanation = 
			"You can change or test the pitch of the voice in this menu.\n" +
			"And, you can add your own Sound types by doing the following.\n" + 
			" 1. Add a new directory such as 'female1' to the following path.\n" +
			"   - YOUR_VAM/Custom/Sounds/ExpressionBlushingAndTears\n" +
			" 2. Add three directories to that path, and place at least one file in it.\n" +
			"   - breath, moan, climax. (Please refer to the 'default' directory.)\n" +
			" 3. Reload the script.";
			MakeVariableString("TEXT:Sound", explanation);
			MakeVariableSlider("Sound Pitch", sound.headAudioSource.pitch, 0.8f, 1.5f, "General", "Pitch");
			//setupUISliders3
#if (EBATWO)
			MakeVariableSlider("Orgasm Strength Max", orgasm.orgasmStrengthMax, 0f, 5f, "Orgasm", "OrgasmStrength");
			MakeVariableSlider("Afterglow Strength Max", orgasm.afterglowStrengthMax, 0f, 5f, "Orgasm", "AfterglowStrength");
			MakeVariableSlider("Orgasm Wave Big Cycle Count Max", orgasm.orgasmWaveCycleBigMax, 0f, 1000f, "Orgasm", "WaveBigCycleMax");
			MakeVariableSlider("Orgasm Wave Big Cycle Count Min", orgasm.orgasmWaveCycleBigMin, 0f, 1000f, "Orgasm", "WaveBigCycleMin");
			MakeVariableSlider("Orgasm Wave Small Cycle Count Max", orgasm.orgasmWaveCycleSmallMax, 0f, 1000f, "Orgasm", "WaveSmallCycleMax");
			MakeVariableSlider("Orgasm Wave Small Cycle Count Min", orgasm.orgasmWaveCycleSmallMin, 0f, 1000f, "Orgasm", "WaveSmallCycleMin");
			MakeVariableSlider("Orgasm Afterglow Big Cycle Count Max", orgasm.orgasmAfterglowCycleBigMax, 0f, 1000f, "Orgasm", "AfterglowBigCycleMax");
			MakeVariableSlider("Orgasm Afterglow Big Cycle Count Min", orgasm.orgasmAfterglowCycleBigMin, 0f, 1000f, "Orgasm", "AfterglowBigCycleMin");
			MakeVariableSlider("Orgasm Afterglow Small Cycle Count Max", orgasm.orgasmAfterglowCycleSmallMax, 0f, 1000f, "Orgasm", "AfterglowSmallCycleMax");
			MakeVariableSlider("Orgasm Afterglow Small Cycle Count Min", orgasm.orgasmAfterglowCycleSmallMin, 0f, 1000f, "Orgasm", "AfterglowSmallCycleMin");
			MakeVariableSlider("Orgasm Wave Big Cycle Interval Max", orgasm.orgasmWaveCycleIntervalBigMax, 0f, 1000f, "Orgasm", "WaveBigCycleIntervalMax");
			MakeVariableSlider("Orgasm Wave Small Cycle Interval Max", orgasm.orgasmWaveCycleIntervalSmallMax, 0f, 1000f, "Orgasm", "WaveSmallCycleIntervalMax");
			MakeVariableSlider("Orgasm Afterglow Big Cycle Interval Max", orgasm.orgasmAfterglowCycleIntervalBigMax, 0f, 1000f, "Orgasm", "AfterglowBigCycleIntervalMax");
			MakeVariableSlider("Orgasm Afterglow Small Cycle Interval Max", orgasm.orgasmAfterglowCycleIntervalSmallMax, 0f, 1000f, "Orgasm", "AfterglowSmallCycleIntervalMax");
#endif
			MakeVariablesSliderThresholds();
		}
				
		public void MakeVariablesSliderThresholds(){
			string tag = "threshold";
			string expPrefix = "Settings for each Stage Threshold";
			string expSuffix = "For each stage, you can set the threshold and the clothes you want the character to equip with this menu.\nIn this Plug-in, tears and drool are implemented as clothes.";
			
			for(int i = 0; i < 6; i++){
				int num = i;
				
				string explanation = expPrefix + num + ":\n" + expSuffix;
				MakeVariableString(MakeName("text", tag, i), explanation);
				MakeVariableSliderNoFunc(MakeName("slider", tag, i), (float)stageThreshold[num], 0f, 1000f);
				dJSSlider[MakeName("slider", tag, i)].setCallbackFunction = (float value) => {
					stageThreshold[num] = (int)value;
					settings["StageThreshold"][("Threshold" + num)]["Value"] = stageThreshold[num].ToString();
//					saveConfig();
				};
			}
		}
		
		public void SetupUIActionButtons(){
			MakeUIPartButton("Load Default", false, Color.cyan);
			MakeUIPartButton("Save Configuration", true, Color.cyan);
			MakeUIPartToggle("Debug Message Off", true);
			MakeUIPartToggle("Display UI Menu", true);
#if (EBATWO)
			MakeUIPartButton("Make her Orgasm", false, Color.cyan);
			MakeUIPartButton("Stop her Orgasm", false, Color.cyan);
#endif
			MakeUIPartSpacer("spacer01", "SectionSeparator", false);			
			MakeUIPartSpacer("spacer02", "SectionSeparator", true);			
		}

		public void SetupUIToggleButtons(){
			MakeUIPartToggle("Auto Expression Off", false);
			MakeUIPartToggle("Auto Blink Off", true);
			MakeUIPartToggle("Expression On", false);
			MakeUIPartSpacer("spacer16", "ButtonSkip", true);
			MakeUIPartToggle("Eyes Control On", false);
			MakeUIPartToggle("Eyes Rollup On", true);
			MakeUIPartToggle("Blush On", false);
			MakeUIPartSpacer("spacer11", 36f, false);			
			MakeUIPartPopup("Blush Type", true);
			
			MakeUIPartToggle("Tears On", false);
			MakeUIPartToggle("Drool On", false);
			MakeUIPartPopup("Tears Type", true);
			MakeUIPartSpacer("spacer12", 2f, true);			
			MakeUIPartToggle("Sound On", false);
			MakeUIPartSpacer("spacer17", "ButtonAndSectionSeparator", true);
			
			MakeUIPartToggle("Nipple Erection On", false);
			MakeUIPartToggle("Clitoris Erection On", true);
			MakeUIPartToggle("Peeing On", false);
			MakeUIPartToggle("Head Motion On", true);
//			MakeUIPartSpacer("spacer13", "ButtonSkip", true);
			MakeUIPartSpacer("spacer14", "SectionSeparator", false);
			MakeUIPartSpacer("spacer15", "SectionSeparator", true);
		}

		public void SetupUISliders1(){
			MakeUIPartSlider("Expression Strength", false);
			MakeUIPartSpacer("spacer20", "SliderSkip", true);

			MakeUIPartSlider("Eyes Control interval Time", false);
			MakeUIPartSlider("BodyMorph Duration Time", true);
			MakeUIPartSlider("Blush Duration Time", false);
			MakeUIPartSlider("Tears Duration Time", true);
			
			MakeUIPartSlider("Breath Strength", false);
			MakeUIPartSlider("Peeing Ratio", true);
			
			MakeUIPartSpacer("spacer21", "SectionSeparator", false);
			MakeUIPartSpacer("spacer22", "SectionSeparator", true);
		}

		public void SetupUISliders2(){
			MakeUIPartButton("Undress All", false);
			MakeUIPartSpacer("spacer34", "ButtonSkip", true);
			
			string tag = "threshold";
			for(int i = 0; i < 6; i++){
				int num = i;
				MakeUIPartString(MakeName("text", tag, i), false);
				MakeUIPartSlider(MakeName("slider", tag, i), true);
				MakeUIPartButtonNoFunc("Set Stage" + num + " clothes", true);
				dUIButton["Set Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.cm.setClothes(num);
					List<string> tmpClothUids = tears.cm.getClothUids(num);
					for(int j = 0; j < tmpClothUids.Count; j++){
						settings["StageThreshold"][("Threshold" + num)]["Clothes"][j] = tmpClothUids[j];
					}
//					saveConfig();
				});	
				
				MakeUIPartButtonNoFunc("Reset Stage" + num + " clothes", true);
				dUIButton["Reset Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.cm.clearClothes(num);
					settings["StageThreshold"][("Threshold" + num)]["Clothes"] = new JSONArray();						
//					saveConfig();
				});	
				
				MakeUIPartButtonNoFunc("Test Stage" + num + " clothes", true);
				dUIButton["Test Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.cm.equipClothes(num);
				});	
				
				MakeUIPartSpacer(MakeName("spacer", tag, i), 35f, false);
				MakeUIPartButtonNoFunc("Show Clothes for Stage" + num, false);
				dUIButton["Show Clothes for Stage" + num].button.onClick.AddListener(() =>{
					SuperController.LogMessage("Clothes for Stage" + num + ":");
					tears.cm.showClothes(num);
				});	
			}
			
//			MakeUIPartSpacer("spacer31", "SliderSkip", true);
			MakeUIPartSpacer("spacer32", "SectionSeparator", false);
			MakeUIPartSpacer("spacer33", "SectionSeparator", true);
		}

		public void SetupUISound(){
			MakeUIPartString("TEXT:Sound", false);
			MakeUIPartSpacer("spacer51", 102f, false);
			MakeUIPartSpacer("spacer52", 98f, false);
//			MakeUIPartPopup("Sound Type(Default)", true);
			MakeUIPartPopup("Sound Type(Personal)", true);			
			MakeUIPartSlider("Sound Pitch", true);
			MakeUIPartButton("Sound Test: Breath", true);
			MakeUIPartButton("Sound Test: Moan", true);
			MakeUIPartButton("Sound Test: Climax", true);
		}
		
		public void SetupUISliders3(){
#if (EBATWO)
			MakeUIPartSlider("Orgasm Strength Max", false);
			MakeUIPartSlider("Afterglow Strength Max", true);
			MakeUIPartSlider("Orgasm Wave Big Cycle Count Max", false);
			MakeUIPartSlider("Orgasm Wave Big Cycle Count Min", true);
			MakeUIPartSlider("Orgasm Wave Small Cycle Count Max", false);
			MakeUIPartSlider("Orgasm Wave Small Cycle Count Min", true);

			MakeUIPartSlider("Orgasm Afterglow Big Cycle Count Max", false);
			MakeUIPartSlider("Orgasm Afterglow Big Cycle Count Min", true);
			MakeUIPartSlider("Orgasm Afterglow Small Cycle Count Max", false);
			MakeUIPartSlider("Orgasm Afterglow Small Cycle Count Min", true);
			MakeUIPartSlider("Orgasm Wave Big Cycle Interval Max", false);
			MakeUIPartSlider("Orgasm Wave Small Cycle Interval Max", true);
			
			MakeUIPartSlider("Orgasm Afterglow Big Cycle Interval Max", false);
			MakeUIPartSlider("Orgasm Afterglow Small Cycle Interval Max", true);

			MakeUIPartSpacer("spacer41", "SectionSeparator", false);
			MakeUIPartSpacer("spacer42", "SectionSeparator", true);
#endif
		}
		#endregion
		
		#region UI RemoveMainUI
		public void RemoveConfigMenu(){
			RemoveUIActionButtons();
			RemoveUIExpands();
			if(dOpenState["Toggles for Main Features"])	RemoveUIToggleButtons();
			if(dOpenState["Sliders for Main Features"])	RemoveUISliders1();
			if(dOpenState["Sound Menu"]) 	RemoveUISound();
			if(dOpenState["Sliders for Stage Thresholds"])	RemoveUISliders2();
#if (EBATWO)
			if(dOpenState["Sliders for Orgasm Features"])	RemoveUISliders3();
#endif
		}

		public void RemoveConfigMenuForce(){
			RemoveUIExpands();
			RemoveUIActionButtons();
			RemoveUIToggleButtons();
			RemoveUISliders1();
			RemoveUISliders2();
#if (EBATWO)
			RemoveUISliders3();
#endif
		}
		#endregion
		
		#region UI RemoveUI Expand
		public void RemoveUIExpands(){
			foreach(var name in expandsNames){
				bool openState = dOpenState[name];
				string spacerName = "spacer_" + name;
				string buttonName = !(openState) ? "[+]Expand " + name : "[-]Collapse " + name;
				if(dUISpacer.ContainsKey(spacerName)) RemoveAnyUI(dUISpacer[spacerName]);
				if(dUIButton.ContainsKey(buttonName)) RemoveAnyUI(dUIButton[buttonName]);
			}			
		}
		#endregion
		
		#region UI RemoveUI SubUI
		public void RemoveUIActionButtons(){
			string[] names = {
				"Load Default", "Debug Message Off", "Display UI Menu", "Save Configuration", 
				"Make her Orgasm", "Stop her Orgasm", "spacer01", "spacer02", "spacer03",
			};
			RemoveUIs(names);
		}
		
		public void RemoveUIToggleButtons(){
			string[] names = {
				"Auto Expression Off", "Auto Blink Off", "Expression On",
				"Eyes Control On", "Eyes Rollup On", "Blush On", "Tears On", "Drool On",
				"Sound On", "Nipple Erection On", "Clitoris Erection On", "Peeing On",
				"Blush Type", "Tears Type", "Head Motion On",
				"spacer11", "spacer12", 
//				"spacer13", 
				"spacer14", "spacer15", "spacer16", "spacer17", "spacer18",
			};
			RemoveUIs(names);
		}
		
		public void RemoveUISound(){
			string[] names = {
				"TEXT:Sound", "spacer51", "spacer52", "spacer53", 
				"Sound Type(Default)", "Sound Type(Personal)", 
				"Sound Pitch", "Sound Test: Breath", "Sound Test: Moan", "Sound Test: Climax", 
			};
			RemoveUIs(names);
		}
		
		public void RemoveUISliders1(){
			string[] names = {
				"Expression Strength", "spacer20", 
				"Eyes Control interval Time", "BodyMorph Duration Time",
				"Blush Duration Time", "Tears Duration Time", 
				"Breath Strength", "Peeing Ratio", 
				"spacer21", "spacer22",
			};
			RemoveUIs(names);
		}
		
		public void RemoveUISliders2(){
			string[] names = {
				"Undress All", 
				"spacer31", "spacer32", "spacer33", "spacer34",
			};
			RemoveUIs(names);
			
			string tag = "threshold";
			for(int i = 0; i < 6; i++){
				RemoveAnyUI(dUIString[MakeName("text", tag, i)]);
				RemoveAnyUI(dUISlider[MakeName("slider", tag, i)]);
				RemoveAnyUI(dUIButton["Set Stage" + i + " clothes"]);
				RemoveAnyUI(dUIButton["Reset Stage" + i + " clothes"]);
				RemoveAnyUI(dUIButton["Test Stage" + i + " clothes"]);
				RemoveAnyUI(dUISpacer[MakeName("spacer", tag, i)]);
				RemoveAnyUI(dUIButton["Show Clothes for Stage" + i]);
			};
		}
		
		public void RemoveUISliders3(){
			string[] names = {
				"Orgasm Strength Max", "Afterglow Strength Max",
				"Orgasm Wave Big Cycle Count Max", "Orgasm Wave Big Cycle Count Min",
				"Orgasm Wave Small Cycle Count Max", "Orgasm Wave Small Cycle Count Min",
				"Orgasm Afterglow Big Cycle Count Max", "Orgasm Afterglow Big Cycle Count Min",
				"Orgasm Afterglow Small Cycle Count Max", "Orgasm Afterglow Small Cycle Count Min",
				"Orgasm Wave Big Cycle Interval Max", "Orgasm Wave Small Cycle Interval Max",
				"Orgasm Afterglow Big Cycle Interval Max", "Orgasm Afterglow Small Cycle Interval Max",
				"spacer41", "spacer42",
			};
			RemoveUIs(names);
		}
		#endregion
		
		#region UIBase RemoveUI
		public void RemoveUIs(string[] names){
			try{
				
			foreach(var name in names){
				if(dUIToggle.ContainsKey(name)) RemoveAnyUI(dUIToggle[name]);
				else if(dUIPopup.ContainsKey(name)) RemoveAnyUI(dUIPopup[name]);
				else if(dUIButton.ContainsKey(name)) RemoveAnyUI(dUIButton[name]);
				else if(dUISpacer.ContainsKey(name)) RemoveAnyUI(dUISpacer[name]);
				else if(dUISlider.ContainsKey(name)) RemoveAnyUI(dUISlider[name]);
				else if(dUIString.ContainsKey(name)) RemoveAnyUI(dUIString[name]);
			}
			}catch(Exception e){
				core.loggerE(e);
			}
		}
		
		public void RemoveAnyUI(UIDynamicButton ui){
			if(ui != null) core.RemoveButton(ui);
		}
		
		public void RemoveAnyUI(UIDynamic ui){
			if(ui != null) core.RemoveSpacer(ui);
		}
		
		public void RemoveAnyUI(JSONStorableBool ui){
			if(ui != null) core.RemoveToggle(ui);
		}
		
		public void RemoveAnyUI(UIDynamicToggle ui){
			if(ui != null) core.RemoveToggle(ui);
		}
		
		public void RemoveAnyUI(JSONStorableStringChooser ui){
			if(ui != null) core.RemovePopup(ui);
		}
		
		public void RemoveAnyUI(UIDynamicPopup ui){
			if(ui != null) core.RemovePopup(ui);
		}
		
		public void RemoveAnyUI(JSONStorableString ui){
			if(ui != null) core.RemoveTextField(ui);
		}
		
		public void RemoveAnyUI(UIDynamicTextField ui){
			if(ui != null) core.RemoveTextField(ui);
		}
		
		public void RemoveAnyUI(JSONStorableFloat ui){
			if(ui != null) core.RemoveSlider(ui);
		}
		
		public void RemoveAnyUI(UIDynamicSlider ui){
			if(ui != null) core.RemoveSlider(ui);
		}
		#endregion
	}
	
}